Change log since official release 1.00

xx.10.07 version 2.2.8 post 1
+ Bug fixes/Cosmetic changes
  Fixed the code for checking directory pathways against server operating system
  Fixed spurious *rename* error message if the name of an uploaded file contains characters that are invalid on some operating systems
  Modified the number of "My Recent LDM Entries" and "What's Viewed" displayed in user profile to 15 (was 50 and 10 respectively)  
  Admin settings/permissions pages highlight all parameters that can be over-ridden within categories, not just those that have been over-ridden 
  Trap seriously malformed urls such as http:// with no site
+ Extras
  Tidied up look of Filmstrip extra (arrows)
+ Languages
  Completed the Spanish translation  

24.09.07 version 2.2.8
+ Allowances
  Allowances also count for all files delivered from site mirrors
+ Extras
  Similarthreads extra patches showthread's 'similar threads' feature to include *similar LDM entries*
  Internal code around calls to the links_addlink_preinsert hook made consistent throughout LDM
+ Hooks
  More hooks inserted into code
+ Permissions
  Add/Edit Category, Edit Entry, Select Category and Set Display Order permissions made inheritable 
+ VBAdvanced
  Tested with vbAdvanced RC2
  Bandwidths displayed by *ldm_tot* module display to 1 or 2 decimal places when appropriate
+ Bug fixes
  Fixed My Profile listing of entries placed in multiple categories
  Fixed LDM's attempt to redirect user when entry has moved to a different category from that given in a url
  Fixed submit bug with Admin/Media Players/edit settings
  Fixed miscellaneous bugs in admin/hits analyses
  Fixed bug whereby invalild default_forumid locks everyone out
  Edit Category command made visible when current user owns the current category
  Add/Edit Entry correctly handle timezones with half hour deltas
  Improved efficiency of code which emails users about updates to their downloaded entries
  Improved error messages for logged in users who lack *can_access_link* permission
  Main edit message boxes correctly pick up *formwidth_usercp* style setting
  Removed the stray text in the bold linkbit

14.08.07 version 2.2.8 RC2
+ Linkbit
  New Modern (top) linkbit added - same as Modern, except everything aligns to the top rather than middle of the row
+ Admin/keywords
  Extended to enabled merging/renaming of keywords
+ Ratings
  Users denied *must_rate_download*/*must_rate_play* permission can still download/play their own submissions without rating
+ Extras
  Add-page-information extra displays arbitrary text withi main displays
  Filmstrip extra tidied up (more admin settings, ajax enabled where possible)
  Spider-me extra tidied up ('spider me' text if icon not found)
  Tagcloud extra tidied up (handles forum permissions)
+ Bug fixes
  Handling of vba thumb sizes corrected
  LDM 'latest entry' information in forum displays handles assigned forum permissions
  autothread - fixed various bugs with cross-posting of comments/ratings; ratings without remarks don't get posted
  Who's Online entries brought up-to-date; Downloading gets recorded correctly

29.07.07 version 2.2.8 RC1
+ Admin
  admin/categories/mass edit categories and admin/categories/mass edit links include option to mass edit the display orders
  admin/import/export includes facility to download Google-type sitemap of your LDM database; imports/exports can be gzipped
+ Allowances
  All files hit on local server count against allowances, even when "links" rather than "Downloads"
+ Add/Edit Entry
  Data entry form modified to clarify options to replace existing entry with url or upload
+ Extras
  external-links-framed opens external urls in an iframe
  import-radiostations imports xml data files prepared using Dream's excellent radiostations hack (vb.org thread 152037)
+ Main page layout
  Category information tidied up
  Show Latest Ratings menu item added, displays most recently rated entries 
+ Ratings
  When *must_comment_and_rate* is set, submit button is disabled until user selects a rating
  Users who can edit other's comments can also change their ratings
+ vba modules
  thumbs module uses cached thumbnail when possible
+ Bug fixes
  Partial content transfers work correctly with IIS webserver

15.07.07 version 2.2.8 beta
+ Add Entry
  *allow_add_multi* setting enables creation of several entries at once
+ Admin
  local_links_init.php (ADMIN_USER_GROUP) extended to allow multiple usergroups to have access to LDM admin
+ Entries
  Size displayed for entries with filetype other than htm/html even if not in attachment table 
+ Extras
  *secureurl* extra added to lock play/download urls to entries/times/userid/ip address
+ Mirrors
  Active/inactive switches added 
+ Ratings
  User avatars displayed within ratings bits
+ Extras
  Jukebox-enhancements extra brought up to date
+ Bug Fixes
  Changed autocreate thread to be inactive by default
  Fixed broken admin layout when improper settings found in database
  Validate entries resets invalid filesizes
  Fixed invalid userid setting on edit entry
  Fixed invalid userid test on edit category
+ Translations
  Arabic language removed - obsolete and very incomplete

25.06.07 version 2.2.8 alpha
+ Categories
  Add/Edit Category allows same username changes as Add/Edit Entry
  autocreate linked forum includes choice whether to display linked forum on forumjump menus
+ Entries
  Autocreate thread/post code extended and integrated into main product 
    (NB: users of existing autocreate 'extra', refer to 'extra' directory for info)
+ Comments and Ratings
  Options to display summary inline within the linkbit or as drop-down,
  *must_rate_download*, *must_rate_play* permissions added to force comment/rating 
   before allowing download/play
  Moderators can create/edit comments by other users and change the submitting user for comments
+ Images
  Options added to Edit Entry to delete/replace existing uploaded image
+ Keywords
  *must_add_keyword* permission requires at least one keyword on add/edit entry
+ Mirror sites
  Mirror sites supported by new admin page. When a download satisfies a mirror test, user is presented
  with list of available mirrors and is asked to choose one.
+ Searching
  *can_search_link* permission allows/denies access to searches
+ Admin
  Tidy hits table (archive/delete) accepts optional list of usernames 
  New settings variable *perpage_download* controls default hits per page on admin/hits
+ Extras
  systematic revision of extras to use LDM admin settings page to control behaviour
  *auto_threadcreate* removed and fully integrated into LDM
  *block-context-menu* extra now works in player windows
  *blockhit-bytime* extra added to allow usergroup d/l blocks by time of day
  *filmstrip* extra provides strip overview of category contents when viewing single entry
  *tagcloud* extra, as per vbadvanced but displayed within LDM
+ vBulletin integration
  apply_censor option defines whether to apply vBulletin censorship features
  vb's forum password protection implemented within LDM
  - when viewing categories associated with a password-protected forum
  - when attempting to view/play entries associated with a password-protected forum
+ vbAdvanced integration
  Keyword tagcloud module added
  Code fixed to work correctly with vbAdvanced versions 2.x and 3.x in function-wrap and global modes
+ Bug fixes
  Fixed bug for players requiring fullurl when playing offsite media files
  Fixed allowance reporting bug (links counted as files on main displays)
  Allowances apply to downloadable files even when force_redirect set to 1 
  Fixed Wimpy Button to work via vbAdvanced when not in forum directory
  Searches work in utf-8 languages (but still don't highlight correctly)
  DOI searches on advanced search work correctly
  Fixed bug whereby image-type entries never gained thumbnail if link_imagesize=0 at time of creation 
  Fixed spurious 'Nothing to show' message when *featured_sites* enabled but none visible in current category
  Fixed bug with *sync_username* parameter, leading to wrong associated userid.

09.04.07 version 2.2.7 post-2 ** Works with VB3.5 and 3.6 **
+ Bug fixes for 2.2.7
  Date/time fixes for languages that use different formatting routines
  Fixed geographical space warp when DST is in force
  "Accept me" forms no longer resize screen
  Wimpy Wasp Flash Player works again
  vbAdvanced modules fixed to work when vba home page is not in forums directory and to show correct number of 'What's Hot/New'
  Fix for unintended and erroneous 'category permission over-rides' after category settings edit
  Fix for Add category/update display order in this category only
  Fix for illegal function calls in moderate/delete entry
  Fix for sql error with admin/debug
  Advanced Search text and user boxes are now standard text inputs rather than textboxes

15.03.07 version 2.2.7 ** Works with VB3.5 and 3.6 **
+ Bug fixes and other changes
  Admin/*cat_desc_popup* option enables a popup showing category's extended description next to the category title in the catbit
  Admin/*word_wrap* controls where long titles/words in text gain a space to allow then to wrap correctly
  Admin/allowances blanks out non-enabled form fields
  Admin/hits improvements and fixes to selection criteria
  Admin/imports and exports are allowed up to 60 seconds cpu if php installation allows this
  Admin/mass edits include 'process all pages' and regex-based edits on several fields with count of entries affected by edit
  Admin/permissions includes transpose opion to list everything by usergroup
  Admin/settings, more settings (including *force_redirect*) can be re-configured on a per-category basis
  Admin/settings *local_file_root_prefix* and *force_redirect*=2 now work correctly together
  Category synchronisation does not create/deletes categories where there are no entries or subcategories
  Hit recording coding error fixed for null entries
  Linkbit/better flagging of expired/not yet visible entries
  Linkbit/date fields fixed with languages that have format overrides
  Main page/warning message displayed if database/category is empty or if current user is not allowed to see anything
  Search/advanced search on category and subcategories no longer produces ridiculous category list
  Search/similarity search bugs fixed (php4 and general sql errors)
  User profile listing includes "show all my entries" link
  vbAdvanced/advanced search module added
  vbAdvanced/thumbs, hot, new modules have new parameter to specify entries per row
  added player for Veoh flash video site via 'extra'

15.02.07 version 2.2.7 RC ** Works with VB3.5 and 3.6 **
+ Bug fixes and other changes
  "Suggest entries like" added, with similarity calculated using overlapping hits, favourites and keywords
  *can_bypass_bandwidth_limits* permission added to enable bandwidth limits to be over-ridden on a per-category basis
  Add/Edit Entry forms now consistently reflect user's time zone
  All the search/find pages accept a userid=N parameter
  Thumbnails automatically regenerated whenever cached size does not match size required for display
  Admin/Download, Bandwidth and Uploads page extended to include summary of each user's uploads
  Admin/Hits reworked to permit mor thorough analyses of users activities
  Admin/Import XML includes option to completely re-initialise LDM
  Admin/page layout improved
  Windows Media Player jukebox works again with Firefox

28.01.07 version 2.2.7 beta ** Works with VB3.5 and 3.6 **
+ Bug fixes and other changes
  *can_view_expired* permission renamed *can_view_hidden* and applied also to hidden entries : NB - existing settings are transferred to new setting
  Edit Entry allows 'expire now' to force immediate expiration
  *hide* and *unhide* entries made into a standard option on the entry add/edit form for users with *can_moderate_links* permission
  efficiency of admin/logjumps code improved significantly
  direct access to post-dated entries prevented
  further work on efficiency of category synchronisation code
  admin settings page catches attempts to use full url in uploads_dir, thumbs_dir
  curl-mediated access of urls on local site no longer fails in safe mode/when open_basedir set
  jumps to local urls which do not have a recognised mimetype work correctly when local_file_root_prefix is set
  hidden entries are really hidden...
  template versions resequenced so that the VB 'obsolete template' warning system will flag potential compatibility problems
  home page stats code and admin 'view hits' code speeded up
  install script modified to run installation code during every (re-)installation
  admin/import xml handles keywords
  added player for PutFile flash video site via 'extra'
  per-usergroup allowances extended to include total bytes uploaded

09.01.07 version 2.2.7 alpha 1 ** Works with VB3.5 and 3.6 **
+ Browser title 
  includes entry name when only one entry is being displayed
+ Categories
  automatic synchronisation tidied up
  'extra' provided so that entries created by automatic/manual synchronisation can autocreate threads
+ Catbits
  new settings enable use of different catbits per category (two provided)
+ Entry expiration
  when 'links_expiry_days' is set, entries are invisible and inaccessible to unauthorised users if either postdated or expired 
  option added to auto-move truly-expired entries to a new category
+ Jukebox
  underlying player handling code redone to 
    - simplifies the process of adding new players and 
    - enables easier selection of players that work on macs and linux
  ratings/comments enabled within jukebox
  players for flash video sites (currently DailyMotion, Google, IFilm, MetaCafe, Sharkle, ThatVideoSite, VSocial and YouTube) available via an 'extra'
  wimpy wasp flv and swf player available via an 'extra'
+ Linkbit
  'title only' linkbit added
  Main linkbits include a "find all entries by this user" search glass
  Default value for link_imagesize (size of displayed thumbs) is read from VB admin setting 'Thumbnail Size'
+ Moderation
  interface improved to enable 'bulk moderate' new entries/categories
+ MyLDM
  a personal page setting out useful information on own interests
+ Ratings
  admin setting *must_comment_and_rate* can be used to require users to give a star rating when commenting (or not, default)
+ Searches
  correctly highlight only/both keywords+text depending on search criteria 
  searches have their own 'search_linkbit' option to control the layout of search results
+ Admin 
  include more checks on possible inconsistencies with VB/php environment
  category listing paginated
  debug page includes options to reinitialise everything
  download 'Content-disposition' header is now controlled by an admin setting rather than hard-coded
  players page added for reconfiguring inbuilt media players
+ Extras
  use of webthumbs to autogenerate site thumbnails as entry image
  use of snap to autogenerate a site image thumbnail as entry dropdown
  autothread plugin extended to allow cross-posting of comments/ratings into autocreated forum thread
  add-mimetypes plugin included to enable a one-shot 'add all the media filetypes to my VBulletin attachment table'
  prototype 'spider me' plugin available to list the forward links in external web pages
+ Bug fixes
  no longer gives error messages when new usergroups are added after LDM is installed
  tidied up multicolumn layouts which involve multiple display order settings
  LDM "show" commands no longer try to highlight 0's (and thereby break certain bbcodes)
  "sort by" drop down works correctly when already in "show" menus
  image generation code no longer balks with Safari
  usernames with some special chars (eg &) can now add entries
 
01.11.06 version 2.2.6 ** Works with VB3.5 and 3.6 **
+ New vbAdvanced module to list most recent new categories
+ New Wimpy plugins added - integrate with wimpy player and wimpy button
+ New plugin in limit_useraccess group to restrict all unregistered users to collective limit
+ Spanish translation updated (thanks ObMob)
+ Down arrow icon available for downloadable files
+ Bugs fixes
  timeout_hit_allow no longer checks on hits on same entry, thus fixing problem with download managers
   that attempt to open multiple channels to the file
  admin/view downloads/delete entries works again
  force_accept modified to record acceptance in the database instead of in a cookie in order to handle
   clients with forceful firewalls and virus software
  moderation code modified to work correctly with changes in VB36
  'view ratings' drop down menu hidden when rating/commenting on entry
  'view ratings' drop down menu visible in tabular linkbit
  subcategories are not shown when user requests display of single entry
  various improvements in curl handling
  curl access works to https: urls and to urls with redirections in place
  entries shown per page is rounded up when link_cols_display>1, to fill the page grid as far as possible
  improved category synchronisation code
  Windows IIS/CGI integration no longer dies if DOCUMENT_ROOT is protected
  VB 3.6.3 image security check incorporated
  'report link' icon visible in tabular linkbit
  link and category descriptions are again left aligned rahter than centred with IE.

03.10.06 version 2.2.6RC ** Works with VB3.5 and 3.6 **
+ Admin/downloads
  Minor changes in layout and control functions
+ Hit counting
  When using LDM as a contact directory (entry's url is empty), viewing single linkid triggers a hit 
+ Image display
  url, e.g., http://yoursite/yourforum/local_resize.php?linkid=123&size=250 can be used anywhere to display a 250px thumb of the image for linkid 123 
+ Linkbits
  New setting 'template_altbit' defines which linkbit is used when displaying only a single item, default Modern
+ VB Profile
  Parameters added in plugins to configure number of 'My Entries'/'Visited Entries' to display in profile
+ Searches
  Title/Keys options added in Quick search, as per VB36's Threads/Posts
+ VBa hot and new modules
  $show_catname variable controls whether to display category name in links_vbalinks template
+ Extras
  force-mp3-to-m3u converts downloads of mp3s to downloads of a matching m3u, to force winamp, etc, to stream the file
  forumhome-thumbs-plugin displays new/hot entries as thumbnails across top of forumhome
  limit-uploads plugin place limits on daily/total user uploads
  sample-avi-image autosets image file for an inserted <filename.avi> file to <filename.jpg>
  stream-mms-videos improves the security of LDM's handling of mms: streams and adds the option to save a stream to file
+ vbAdvanced modules
  hot and new modules have optional switches (see inside code) to include category name in vba list
+ Bugs fixed
  http://user:pwd@site/file.xxx url format works properly
  several functions renamed to avoid potential clashes with other hacks
  now use inlinemod style for customised/inherited LDM admin settings and permissions bits
  bbcode, smiles, images, html admin settings work correctly and editor toolbars adjust accordingly
  mms format now plays inside jukebox
  admin scan fixed (broken in 2.2.5)
  use of short link bit no longer triggers divide by zero errors
  hitting entries associated with invalid forums no longer produces sql error 
  usernames with quotes no longer produces sql error
  LDM icons can now be in gif, jpg or png format
  navbar errors fixed in search module
  mp3 files with no id3 image no longer crash certain versions of php
  downloads into slow channels (e.g. streaming into winamp) no longer die mid-way through transfer
  curl transfer work ok when urls contain spaces
  invalid 'file rename' requests detected during add/edit entry form
  correct messages displayed when file uploads exceed allowed space
  autothread extras do a better job of displaying the associated image in the thread

10.08.06 version 2.2.5 ** Works with VB3.5 and 3.6 **
+ Add/Edit Link
  Fields that are not available to user are not displayed
+ Protocols
  Supports mms protocol
+ RSS2 feed
  New 'extra' - old 'local_links_external' script withdrawn
+ Bugs fixed
  htmlspecialchars_uni used consistently, avoids messing up unicode fonts
  extra information added to admin info table to help debug
  Report of 'invalid email' when editing enties submitted by unregistered user
  No longer crashes when moderator accepts entry and email notification to user is turned on
  Additional tests within 'report link' and 'send to friend' to block spammers
  linkbit_short template fixed
  Product update no longer wipes out customised templates
  VB function cache_styles() copied into LDM because of problems on some sites

Partial translation into arabic provided in the development/phrases directory

30.07.06 version 2.2.5 rc ** Works with VB3.5 and 3.6 **
+ Add/Edit Link
  Admins can change the name files are given on download
  'Email on update' option to send messages to everyone who has downloaded an entry when the entry is edited
+ Admin
  Option to 'quick view' the various linkbits (intended to become an option to facilitate tailoring linkbits)
  Option to mass empty/delete/desynchronise categories
  Admin/mimetypes summarises # files per filetype and whether the types are handled as downloads or links
+ Bandwidth
  Usage by unregistered users tracked against individual IP address rather than as a usergroup
  Presentation clarified to simplify setting (e.g.) K Mbytes per N days 
+ Categories
  Options to autosynchronise categories with web server file system
  Option (cat_depth_indent) to indent categories in main category display according to depth in tree
  Option (cat_sub_display_perline) to set number of subcategories per line in the catbit
  Option (links_expiry_days ) to 'expires' entries after specified number of days, then only visible to users with can_view_expired privilege 
+ Hooks
  Extensive changes and many new hooks added
  forumbit_display plugin shows number of entries in whole database when called at root level
  patch_forumhome plugin made an optional extra rather than installed as inactive
+ Import/Export
  Admin/import/xml imports categories and entries from previous xml export, optionally reinitialising database or merging with existing contents
+ Jukebox
  Option of in-line/new window launch for Jukebox
+ Linkbit 
  All linkbits tidied up and with better popup messages
  Main linkbits display current category name when only one entry displayed
+ Moderation 
  Can be enabled/disabled per category
+ Sorting
  By submitting user
+ Thumbnails
  Option to create thumbs on link creation or (now by default) on first display [makes scans much faster at cost of slower first display]
+ User profile integration
  Lists user's latest entries as well as latest hits
+ WYSIWYG editor 
  Available for add/edit/rate link 

+ Extras added
  patch-forumhome-newlinks sets up list of new/hot links for forumhome
  two version of lightbox addin, a simpler/more reliable and a fancier version, plus further fixes
  limit_useraccess fixed and with two sample plugins a) to restrict users to one download per entry or b) no downloads until N posts

+ Bugs fixed
  Attempts to access entries that have moved to another category trigger an HTTP 301 redirect
  Edits no longer trigger "new entry" message on category if latest date becomes earlier than user's last visit
  id3-handle plugins no longer kill LDM if getid3 subdirectory uploaded incorrectly
  Keywords can contain quotes
  Layout of ratings page tidied up
  max_textlength, maximum length of category/entry description works correctly again
  Realmedia jukebox filetypes modified to avoid starting with characters 'rm '
  Removes html from phrases before building the browser title 
  Tidied up the ratings and comments page
  Thumbnail and typebit urls (e.g. vbadvanced modules) use create_full_url()
  XHTML corrected in admin/settings pages

= prune_expiredlinks cron job extra has been withdrawn

01.05.06 version 2.2.1
+ Add/Edit Link
  New permission: can_set_category
+ Jukebox
  Support added for DivX browser plugin
+ Linkbit
  Hard-coded html (editbit, favbit) in linkbit creation moved into new templates links_editbit, links_favbit and links_imgmag
  New linkbit (links_linkbit_greg) added
+ Extras
  id3-handles extended to handle m3u files
  lightbox plugin to provide neat effect for image magnification
= bugs/features fixed
  Handling of closed categories in add/edit link [proviso: workaround IE bug with handling disabled options]
  Spaces in filenames no longer kill 'magnify thumb'
  Tooltips work with IE for Edit and Add to Favourites icons
  Missing double quote added in main admin template
  auto_thread plugin no longer randomly triggers moderation of new autoposts
  VBAdvanced modules no longer pre-load text into the faq module search box

02.04.06 version 2.2.0
Consolidates all changes/fixes since 2.1.0
+ Extras
  Sample plugins provided for these features:
    - Process mp3 id3 tags during directory scans and in jukebox display; 
    - Read mpeg file to size video windows correctly 
+ Featured sites
  Not displayed when individual linkbit selected for display 
+ Uploads
  Admins can upload files larger than the restrictions imposed by mimetype maxsizes (but cannot exceed php.ini limits)
= bugs fixed
  display of custom avatars held in database
  permissions checking against extended usergroups
  entries with null urls no longer create ghosts of other entries with links_linkbit_short template
  file uploads correctly keep their names after entries are edited

01.04.06 version 2.1.6 RC3
+ Featured sites
  Admin featured_linkbit setting added to enable choice of linkbit used in featured sites
  All featured_* settings are now inheritable, so that different categories can have different featured sites' behaviour
= bugs fixed
  category selection menu expand/collapse only shown with menu, not checkboxes
  htmlspecialchars to protect quotes in links titles
  profile hits list parses bbcodes
  autocreate plugin creates thread url which still works ok after category move
  autocreate plugin tells user that thread has been created 
  partial content handling fixed so that Adobe Acrobat works ok (don't handle or encourage multiple partial content requests)

26.03.06 version 2.1.6 RC2
+ Add/Edit Link/Category
  Category 'use instructions' moved into inheritable display settings
  Drop down added, listing upload size limits by filetype
  Most error messages now return to the form rather than the category
  URLs in category description/extended description and link description autoparsed into url BBCodes
+ Administration
  Setting added to allow/prohibit duplicates by default
  Clearer information given when admin/scan fails to open directory
  Already-processed files can be re-inserted during a subsequent scan
+ DOIs
  edits work
  doi parameter available on action=jump
+ VBa modules
  have access to $linkcatname
+ Extras
  Sample plugins provided for these features:
    - Limit the number of times a user can download a given file
    - Autocreate threads in associated forums when new links are added
= bugs fixed
  linkbits only report filesizes of entries that point to downloads
  url status correctly changes to OK during revalidation
  Admin pages give more links to the on-line manual

12.03.06 version 2.1.5 RC1
Consolidates all changes from 2.1.0 and also:
+ Avatars
  Code and setting added to display user avatars in the linkbit
+ Digital Object Identification
  DOI handling added to link entry and search as an option 
+ Download
  'Agree to these terms' asked on entry to LDM/category rather than per link and answer held in cookie
+ Hooks
  Hooks added at some strategic places - see section 8 of the LDM manual
+ Administration
  Settings added to limit maximum text length of main link/category description fields
= bugs fixed
  Repaired the handler code for the uploadfiletypes setting 
  Repaired array handling for php 4.3.2 and earlier
  'Add link' with null url defaults to 'allow' instead of 'disallow' duplicates
  Modified debug table handling to prevent overflow
  Improved the error message when user forgets to tick the 'confirm' boxes for delete entry/category

01.03.06 version 2.1.3 beta 3
+ Ratings/comments
  Main linkbit offers popup showing most recent comments and ratings
+ Featured sites
  New setting controls whether these appear in all categories or only their own
+ Administration
  Settings added for open local/remote links in new or current window
= bugs fixed
  Category menu displays correctly with forum permissions in add link, etc
  vbAdvanced ldm_tot module fixed when *days_seen_on_portal*=0
  Admin buttons work correctly with Internet Explorer
  Forumhome plugin uses $stylevar settings for buttons directory
  Forum variable title_clean is set during creation of linked forum
  File sizes are grabbed for remote urls when curl library is available, means that http 206 handling works for these files
  'Show Random Links' displays correct number of entries when keywords enabled
  'Who's Online' text uses LDM database name if set

26.02.06 version 2.1.3 betas 1 and 2
+ Bandwidth/File limits
  When enabled, information on the user's current consumption is given in category headers
+ Categories
  Open/close option is available within add/edit category
+ Entries
  Add/edit link 'display order' option defaults to 'all categories' rather than 'just current'
  Only users with *can_moderate_link* permission can change the submission date/review frequency
+ General
  Support added for HTTP 206 partial downloads
+ Keywords 
  Entries can have associated keywords. These are searchable through regular and profile searches and
  are add/edited within add/edit link and within Admin/Categories/Mass Edit
+ Quotas
  users get to see their current consumption in the header when quotas are active
+ Searches
  Extensive changes (keywords, before/after...)
  Admins can save and retrieve searches and use them for mass edits
+ Stats displays tidied up and require fewer database reads
+ Administration
  ImportExport: XML export option available implemented; separate 'extras' script provided for xml imports
  Categories/Mass Edit: paginated list of entries; facility to 'expire' entries 
  that have not been visited during the last N days; add/remove keywords
  Statistics: Added new options: rebuild thumbs, edit keywords, expiry entries
  Settings: force_accept setting added - downloads only begin after links_agreement template accepted
+ Extras
  Forumhome stats box plugin provided to show summary stats about LDM database contents (see patch-forumhome)
  VBadvanced module ldm_tot added, giving overall board statistics (links, comments, categories, hits and bytes served)
  Script provided for importing a complete LDM database from xml
= bugs fixed
  > Unregistered users offered 'Please register' dialogue when they try to rate links
  > Magifying glass icon added for image enlargement
  > curl coding bug fixed in creating thumbnails from images held off-site
  > category jump menu hides protected categories from user
  > icon images display correctly on Mac/Safari
  > 'remove favourite' works again
  > document size redetermined on edit link
  > downloads work correctly when there is a mismatch between filesize recorded in database and actual filesize
     (consequence: can no longer give accurate download progress message when downloading off-site files)
  > forum permissions applied correctly when displaying featured sites
  > phrased "My Recent LDM Hits" for profile integration

07.01.06 version 2.1.2 beta 1
+ Categories
  can have inheritable settings defining category/link appearance
+ Email notifications available: to moderator when link submitted/to user when accepted
+ Featured Sites (=a selection from selected users' favourites) 
+ Final tweaks to User Profile integration
+ Linkbits
  New linkbit available (intended for photolibraries)
  Option to display multiple columns across some linkbits
  General tidying up of linkbit templates (icons, layout)
+ Thumbnail images generated whenever possible during link creation/edit, rather than on the fly.
  'thumbs_dir' indicates where these thumbnails are stored
  Images generated using resample algorithm rather than resize algorithm to obtain better image quality
+ Admin settings page restructured into groups and new admin settings/permissions added:
  'default_style' - style to use for whole LDM board
  'moderate_email_submit' and 'moderate_email_accept' - enables confirmation emails
  'cat_icon' and 'cat_icon_new' - alternative category icons
  'cat_cols_display' and 'link_cols_display' - vary columns of categories/links
  'can_link_files' - usergroups has permission to add urls (sister to can_upload_files)
  'featured_user_faves' and 'featured_sites' - controls over featured sites
  'category_jump_menu' - option to disable the drop down category jump menu
= bugs fixed
  > 'Report bad link' works correctly
  > Phrased the admin xml file
  > LDM checks for some valid mimetype information for Jukebox files
  > Improved image quality of thumbnails
  > 'Scan' code re-written to behave more consistently
  > improved (much faster) algorithm for building category jump menu

19.12.05 version 2.1.1 beta 2
+ User Profile integration revised
  hooks onto admin-selected fields in profile

12.12.05 version 2.1.1 beta 1
+ Admin pages improved
  better information when invalid parameter settings entered
  yes/no radios for appropriate parameters
+ Default permissions for new links taken from parent category rather than global default_forumid
+ Daily user file download and bandwidth limits available
+ File uploads retain their name when downloaded
+ New *cat_cols_display* setting controls # columns in catlist
+ New *can_save_musicbox* permission defines whether users see the open/save as hyperlink for Jukebox media files 
+ QuickTime plugin included in Jukebox 
  *Warning* - if upgrading LDM, manually remove "mov" from *musicbox_filetypes_realplayer* filetypes
+ Thumbnail images can be uploaded when uploads enabled
+ 'Update to current time' checkbox added to Edit Link form
+ Uploads of thumbnail images available
+ UserProfile integration (off by default)
  'Show MySearch' driven by parameters in User Profile
  Reveal user's recent LDM hits in profile
+ Users with *can_moderate_link* can change (Ajax-enabled) name of user who submitted entry
= bugs fixed
  > Phrase order in browser title changed to match VB's format
  > Some unnecessary links removed from the Jukebox display
  > Hard-coded phrases moved from plugins into phrases file

23.11.05 version 2.1.0 (first release 17.11.05)
The final release of 2.0.6/2.0.7 with the following additions/fixes
+ Abbreviated/Full linkbit available as user option (collapse bit on links display)
+ Category mass edit features extended considerably
+ '$linkhit' variable included (allow people to show ranking in current display)
+ 'can_view_names' permission distinguished from 'can_view_hits'
+ Plugin patches forumhome to give latest link info for any category links
+ Plugin patches admincp user edits to catch new usernames
= bugs fixed
   > attempts to access restricted links via sendtofriend displays 'no access' template
   > wording changed for default ldm banner text
   > deprecated 'call by reference' syntax corrected
   > Category selector omits categories that current user cannot visit
   > Admin functions use standard VB3.5.x download utility call
   > local_resize no longer glitches on remote files
   > Empty upload filetype lists handled correctly
   > Includes thumbnails in linkbit_table; image urls in thumbnails behave according to template
   > SQL queries consistent across all functions (fixes search bugs reported by Slave)
   > Category collapse state remembered correctly
   > Various items tidied up a la Slave
   > Edits to uploads catch changes to autoimages

28.10.05 version 2.0.7 Release candidate
+ Category selector included within main displays
+ Searches default to looking for the string as entered (rather than the individual keywords)
+ Admin can restrict upload filetypes beyond the list given in the VB attachment table
+ New linkbit template included, enabling two-stage viewing of links
= bugs fixed
   > Import uses current datestamp (rather than 1/1/1970!)
   > Linkbits have anchors so that link edits/inserts return user to the right place 
     on the screen
   > Various security checks added for uploaded images
   > Data entry for 'When Submitted' reflects site's date/time settings
Second beta
+ Images in category bits
+ 'Please wait' message displayed after add/edit link
+ 'Sort links by hits in last 30/7/1 days' added
= bugs fixed
   > Admin drop-down menu correctly accesses renamed scripts 
   > Streamer records hits
   > Url in linked forum corrected
First beta
+ Add/edit link includes option to set a different date/time
+ Streamer handles Real Player as well as Windows Media Player and looks nicer
+ 'Sort links by rating' included
+ Searches paginated and advanced search offers 'sort by'
+ Mass edit has a 'mass delete links' option
+ Link and category urls can be presented in search engine friendly form
+ A simplified url mod_rewrite functionality is available
+ VBAdvanced interface jumps to link description rather than straight to link
+ *show_hit_parade*=2 includes list of most popular hits in each category
= bugs fixed
   > syntax of filetype searches clarified/made more flexible
   > catbit respects displayorder
   > hitparade and vba modules respect the *can_access_link* and *protected_link* settings
   > normal forumjumps are hidden if site has turned them off
   > *sortby* request works with subcategories as well as links
   > installer catches attempts to upgrade before new code has been uploaded


14.10.05 version 2.0.6
+ uploads available for authorised users within specified size and space limits
+ when thumbnails enabled, thumbnails are automagically created for new image links 
  during normal entry when no other link specified, and during scans
+ LDM home page displays statistics if *show_hit_parade*=1 (default), including the
  most popular entries in *days_seen_on_portal* days. Statistics box is collapsible.
+ searches extended: find uploads, find by filetype
+ new *protected_link* setting controls behaviour of linkbit when *can_access_link*
  setting is off for this user
= bugs fixed
   > interface with vbAdvanced tidied up
   > deals with situations where VB admin has turned off the forum jump menu
   > jukebox works with vb35, checks user is running windows
   > moderation of links with review frequency set works correctly again
   > catches html in category titles so breadcrump isn't screwed up
   > in main display, categories are sorted according to same scheme as links
   > in scans, trap filenames with some magic characters
   > multiple hit detection within timeout period in record_hit() works again
   ** This bug meant that earlier versions failed to trap multiple hits by the same user 
      on the same link within the period timeout_hit_recording. Consequently your downloads 
      statistics may be inaccurate, e.g. if users 'double-click'.  If you care
      about this, upload local_links_fixdlds.php from the development/fixes 
      directory into your main forums directory, run the script once, then
      delete it from your site.
= coding style
   > new global variables ($LINKS_SCRIPT, $ADMIN_SCRIPT) instead of hard-coded script 
     names in templates
   > <?php tags used consistently in code files


24.09.05 version 2.0.5
+ rating/comments system extended to allow users to make multiple comments (one rating)
+ option included to update existing permissions when *default_forumid* is changed on admin page
+ users with *can_set_display_order* permission see the display orders in the linkbit 
+ category forum links to work both ways category<=>forum
+ 'advanced search' added, e.g. to limit searches to certain categories
+ option in edit link to retain or update the original timestamp
+ interface provided for vbAdvanced 2.0
= layout of category home page modified to provide better overview
= admin/settings and admin/permissions split into two pages
= bugs fixed
   changes to default sort order work again
   another attempt to deal correctly with changes to category forum links
   another attempt to deal correctly with category display orders
   cached missing template (styleselect)
   phrasing tidied up
- removed support for obsolete vbindex interface

29.08.05 version 2.0.4
+ LDM template group created within main VB admincp style display
= bugs fixed
   reporting of access permissions in admin/categories
   redirection after moderate link
   navbar and title settings when texts include bbcodes
   handling of unset monitor_dir
   search facility (broken since v2.00 alpha 1!!)
   mass edits
   
19.08.05 version 2.0.3
+ Uses cURL library if available when *allow_url_fopen* is switched off in php.ini
= bugs fixed:
   addslashes check on admin param settings

16.08.05 version 2.0.2
+ categories now have own preferred sort orders
= admin settings include a master title for the LDM database, used in navbar
= bugs fixed:
   corrected edits to display order when multiple categories selected
   corrected links_footer template to reflect standard style
   corrected file check handling when allow_url_fopen=Off

04.08.05 version 2.0.1
+ categories have styles
+ ratings system rewritten to incorporate user comments
+ 'report bad link' added
= installation process integrated with VB3.5 Product Management system
= integrated via plugin with Who's online

24.06.05 version 2.00 alpha 1
= initial release for VB35
+ option to carry out searches using either SQL FULLTEXT or LIKE methods
+ code security tightened up
+ parameter added to restrict local file downloads to part of the local directory tree
+ unregistered users never see unmoderated links, even if they created them

# -------------------------------------------------------------------------

23.04.05 version 1.60

# main script

- Home category indicates number of new entries since last visit
- What's New / days_seen_on_portal setting extended to enable display of these new entries
- installation script now handles import of phrases in more than one language
- add link form includes option to display an associated thumbnail image (only if *link_imagesize*
  is set to a non-zero size using admin page)
- add link form includes option to create/not create entry if the entry already exists in database
- code for mass edits (accessed via admincp) tidied up
- installation script modified to give better indication of flow 
- VB phrasing completed (I hope!!), including for admin script
- bugs fixed:
   hard coded admincp directory
   new categories had wrong parents in 1.56
   php5 coding (sloppy use of $this)
   wrong number of random links/hot links shown when entries contained in multiple categories
   uncached template in edit category
   text messages missing in mass edit/forum
   totals missing in admin/download statistics
   attempts to view non-existent categories trapped
   installation script call to xml parser fixed for php5
   massedit ok when the existing forumid is invalid (e.g. because forum was deleted)
   php error trapped if user leaves url field as http://
   validation script, jump to next fixed
   double quotes in fields trapped when exporting as csv file
   missing phrase (*New*)
   trap null value return in admin script
- better database validation (startup/in admincp)
   links with invalid associated forumids
   categories with invalid parentids
- admin/category structure layout changed to give better overview of associated forums/usergroup protections
- new admin defaults a) timeout period between recording multiple hits of the same file,
  and b) timeout during which a user cannot access another file 
- delete option within admin downloads analysis replaced by backup as csv then delete
- alternative linkbit templates provided (default uses a fieldset,the other is the old-style table row), 
- alternative category selection templates (pull down menu/list of checkboxes), 
- star rating displayed using standard VB stars rather than in text form

- code for addlink action accepts optional parameters (url=, name= and description=) setting initial values
  allowing use of Slave's IE javascript to preload new link entries

19.02.05 version 1.55

# main script and templates

- introduced VB phrases (group local_links) for all main script actions (but not for admin script actions)
- added option automagically to create/delete named subforum that redirects user here during add/edit category
- added "Show My Links"
- added "Send to Friend"
- added jukebox facility for Windows users
- strip out bbcodes in category names when constructing navbar (didn't look too good...)
- users with can_set_permissions can bulk change link permissions when editing category
- admin option added for mass moves of links to a new category
- links are flagged as "new" (i.e. bold-faced) if size/url changes on an edit or validation
- admin script looks for ip2country code (http://codewalkers.com/seecode/521.html) 
  and, if found, analyses downloads by country when IP option is selected
- fixed bug with moderation (not all items visible to the moderator)
- moderation looks up additional user permissions for forum associated with category, enabling 
  different moderators to be set for each category
- fixed bug with admin page (scan, import, export triggered permissions reset, introduced in 1.51)

15.01.05 version 1.51

# main script

- fixed bug in Favourites handling (each user's favourites became invisible to other users)
- added "Show Anything!" option (random links)
- made subcategory display like forum display, adding two parameters on admin settings
- fixed bug when displaying links in multiple categories
- fixed bug with access mode for links on local filesystem
- reduced # database writes after changing settings/permissions

30.12.04 version 1.50

# main script

- tidied up code to improve handling of some features introduced in v1.45
- consistently correct indicatation that a link is or is not a Favourite
- option added for moderator to hide as well as delete links, e.g. so that repeated 
  scan imports do not keep picking up files that are not wanted
- correctly returns to current display set after marking a Favourite
- menus modified to make command placement more intuitive 
- Add Link moved onto the main menu bar to make this option more visible 
- script now handles irc: protocol correctly provided user has a suitable irc client 
  installed
- force_redirect extended to provide three options: script handling, browser redirect, and 
  standard html tags 
- added additional option to dump the links database
- extended the scan code optionally to search subdirectories and to use ignore.dat files

15.12.04 version 1.45

# main script

script split into three files:
- local-links.php for main user functions
- local-links-admin.php for administrative functions
- local-links-include.php for utility code

- added "My Favourites" links
- admin can scan web site directories for new files
- improved admin options for tracking downloads (by user, date, IP)
- linkbit template reveals submitting username to usergroups
  who have can_see_hits privilege
- What's Hot/What's New moved from Search menu to Links menu
- several bugs fixed: 
  forumjump had disappeared in v1.35
  crashed if user specifies f= instead of forum=; 
  traps errors from open_basedir environment setting; 
  wrong category counts were given if the category hierarchies were edited; 
  blank links fields appeared after certain edits because of faulty pagenumber;
  force MYISAM table type for linkslink table (FULLTEXT searching)
  initialise some empty VB arrays
  correctly translate cr/lf on file import
- general tidying up of code to block risks of SQL injection hacks

# install script
- adds new admin settings to handle directory scans

16.10.04 version 1.41

# main script
- added option to change display order of categories
- added option selectively to allow/turn off html, bbcode, smilies, html in 
  links/categories titles/descriptions
- added option to allow new links to have an empty link, i.e. just a name
  and description
- added option to skip hit tracking for selected usergroups
- extended import syntax to include categories and adds export command
- traps consequences of open_basedir being set in php.ini
- fixed bugs in 1.40: version variable not set

# install script
- upgrades lcat table to include display order field
- adds new admin settings to handle category display order
- adds new admin settings for display html, bbcode, smilies, images

2.10.04 version 1.40

# main script
- added option to change display order of links
- added capacity for regular review (=remoderation) of links
- added field in category table to hold data entry instructions for the category
- fixed bugs in 1.35 when moderating and when removing permissions from all usergroups
- fixed bug in edit during moderation

# install script
- upgrades ltoc table to include display order field
- adds new admin settings to handle display order
- upgrades links table for re-review/moderation dates fields
- upgrades category table for data entry instruction field

05.9.04 version 1.35

# main script
- what's hot/what's new added to search code and header template
- jump syntax extended to allow action=jump&link="catname/linkname" for direct lookup and jump
- fix to pagination bug with multiple category assignments
- option to display file type icon in linkbit
- included code to build forum list (in case user has opted to turn this off)
- added admin options to force a redirect rather than read/rewrite (lower bandwidth/cpu at cost of 
  exposing link source and no control over headers)

16.8.04 version 1.30

# main script
- linkbit flags links that sit in multiple categories
- successive linkbit and catbit styles now alternate between alt1/alt2
- ftp protocol added
- new admin settings introduced:
  control whether link/category count goes one level or tree deep
  add meta tag to control how robots index/follow links
  can_see_protected_links_on_portal also available for main links displays, i.e. option
  to show all links/categories even if protected
- admin table now initialised in the installation/upgrade script
- admin page reorganised, with some additional options including
  an "import" csv option to mass-import links and forum selection changed to a drop down menu
- checks version of MySQL before attempting to search IN BOOLEAN MODE
- corrected several bugs, including links to files at sites like sourceforge and illegal forumids

# install script
- checks and reports version of mysql
- initialises admin table with variable descriptions per variable rather than in template
- size of downloads id field extended

16.6.04 version 1.25

# main script
- admin can clear ratings from a link
- boolean fulltext searches with highlighting
- user facility to sort links display on name, hits, date; admin sets default
- local file access rewritten so that admin can specify to use the file system
  rather than the web site as root (warning: this creates a potential security risk)
- bug fix for usernames containing quotes
- changed a print_standard_error to print_no_permission

# install script
- FULLTEXT index on (linkname, linkdesc)

15.5.04 version 1.22

- bug fixes in pagination
- new admin setting to allow admin to fix the number of links displayed per page
  overriding the user's preference

09.5.04 version 1.21

- facility to close/reopen categories
- provide variables recording total number of entries in category tree
- bug fixes of 1.20 - hotlinks template and category moderation

08.5.04 version 1.20

# main script
- moderation of links and categories
- permissions check against extended usergroup settings
- file sizes recorded for off-site downloads after first visit
- ability to search on userid
- trap attempts to use non-http/local protocols
- bug fixes:
  had called mysql_insert_id rather than site->insert_id
  hit ratings were broken in version 1.10
  returned to v1.01 headers for downloads - problems with acrobat

# install script
- new column added to links table to flag moderated/not moderated

18.4.04 version 1.10

# main script
- links display uses standard VB pagination
- categories keep track of number of links and date of latest entry, highlighting new entries
- file downloads from local site include a progress count
- file download headers changed to force a 'save as' dialogue
- handling of seemingly broken links changed, a) on entry/edit and b) on view
  in case the link really is working but just seems broken

# install script 
- category table definition modified

27.3.04 version 1.01

# main script
- changed window to _blank (was _new) in link_admin, links_linkbit, links_hotlinks templates
- map spaces to %20's in cleanto_fopen()
- always open/check download files using cleanto_fopen() to get consistent error handling
- fixed bug with downloadable files less than 1K showing up as unavailable
- guard against sites that have enabled zlib compression
- timeout check in download record to guard against people who "double click"
- make bbuserinfo global in get_linklistbit so users csn edit own posts

# install script 
- index only created once on ltoc table
- script moved to admincp and uses admincp style
- check settings of allow_url_fopen and zlib_output_compression in php.ini
- missing parameter for table name fixed

5.3.04 version 1.00a

# main script
- fixed category edit bug when default_forum = -999
- removed possibility to create a loop of categories when editing (child=parent)
- added username/userid when entering new category into database
- added more error checks against bad arguments
- modified links_header template, changed $foruminfo[title] to $this_navigation_title

1.3.04 version 1.00 released